Plugin Overview

HouseBot IR (Infrared) Device Plugin Overview

The HouseBot IR Device is a Software Device that provides control of hardware through Infrared (IR). Almost any equipment that is controlled with an Infrared remote control can be controlled in HouseBot using the IR Device Plugin.

Sending IR commands to equipment is functionally the same for all equipment. However, the commands and IR Codes that are sent vary quite a bit. To take advantage of this commonality and to provide support for an unlimited number of IR controlled devices, the IR Devices Plugin is designed to be a generic and configurable Plugin.

The IR Device Plugin on its own does not actually represent any specific IR device. Since all IR controlled equipment vary in their feature and commands, the IR Device Plugin is data driven to allow custom Devices to be created by the user. Therefore, there will not be a Device listed in HouseBot for the "IR Device".

HouseBot ships with several standard IR Device definitions. These Device definitions can be used as they are if they match the functionality of the equipment to be controlled. Or they can be easily modified to match the functionality of the equipment.

Any IR Device can also function as an IR Receiver if the Hardware Interface supports this functionality. See IR Receiver for more information on receiving IR Codes.


Configuration

Configuring IR Devices

To create an IR Device:

  1. First be sure that a Hardware Interface that supports IR has been configured in HouseBot. If one has not been configured, do this before configuring the Device.
  2. From the HouseBot main menu, select "File / New / Device...".
  3. The New Device Wizard will prompt you through the setup.
  4. Select the "Requires Hardware Interface" radio button.
  5. Select the Hardware Interface. Only Interfaces that support sending IR will be available.
  6. Select the name of the Hardware Device definition in the 'Type of Device' list. The list shows existing IR Devices that have definitions. If a matching Device definition is not found in the list, a new Device definition will need to be created to complete this step. For more information on creating Device definitions, see the section on creating Device definitions in the main HouseBot on-line help. See the note below for an alternative method for creating IR Devices.
  7. Give a unique and descriptive name to the Device.
  8. Associate the Property Values of the Device to IR Codes that were configured in the Hardware Interface. If no Remote Controls and IR Codes have been configured, return to the Hardware Interface and learn the IR Codes that will be used to control the new Device. After the codes have been entered into the system, return to this step and associate the Property Values to the new IR Codes. See this section for more information on associating Property Values to IR Codes.

The Properties that will be available to the Device are specific to the Device definition selected.

Note:

  • An alternative method for creating an IR Device is to use the blank "Your IR Controlled Device" definition that ships with HouseBot. After creating the Device, Properties can be manually added by right mouse clicking on the Device and selecting the Add Property... menu item. If additional Properties are needed, use the Property Manager to create any Property and Property Value needed.


IR Receiver

If supported by the Hardware Interface, any IR Device can also receive IR Codes. The received IR Codes can trigger Tasks to perform any action.

The simplest way to create a new IR Receiver Device is to simply create a new IR Receiver Hardware Device. However, any IR Device can be setup to receive IR Codes by adding the IR Code Number Received Property to the IR Device. The Property can be added to the Device by right mouse clicking on the Device in the Tree view, selecting Add Property... from the menu, and adding the IR Code Number Received Property.

Note:

  • If adding the IR Code Number Received Property to an IR Device, HouseBot must be restarted for the new Property to be recognized by the Device.

When the Hardware Interface receives and recognizes an IR Code, it will notify all IR Devices that have the IR Code Number Received Property of the IR Code Number that was received. The IR Device will set the IR Code Number Received Property value to the numeric value of the IR Code.

To initiate a Task when a specific IR Code is received, create a new Task and test the IR Code Number Received value for the specific IR Code. If the test passes, the Task will execute any standard Task list actions. For more information on creating Tasks in HouseBot, see the main HouseBot on-line help. To find the IR number of a specific IR Code, navigate to the IR Code in the Remote Control Library (found in the Tree view). Then select the IR Code needed and the IR Code Number will be shown in the IR Code property window.


Using

Using the IR Device

Controlling equipment using the IR Device Plugin is no different than controlling any other equipment in the HouseBot system. By abstracting the functionality of the devices and their protocols into simple Properties and Property Values, controlling any Device is done exactly the same.

For example, to change the channel of a Cable Tuner that has been configured as an IR Device, simply change the Channel Property Value to the desired channel number. This change can be initiated from a Software Remote, Task, script, or from the HouseBot user interface. The system will find the IR Code that is associated with the new channel number and request that the Hardware Interface send the IR Code to the Cable Tuner.